:: Specify any parameter to generate script without launching afterwards.

:: 2.4.5.0	2011/07/24
:: http://a3images.sf.net
::  2010, Ivan Ivon (ivan.ivon@gmail.com)

@echo off

set outScript="%CD%\%~n0_exec%~x0"

set settingsDir=%~n0.settings

if "%stdout_redirected%"=="" (
	set stdout_redirected=yes
	"%comspec%" /c "%0" %* > %outScript%
	if "%~1"=="" call %outScript%
	exit /b %errorlevel%
)

echo. 1>&2
echo Settings folder: %settingsDir% 1>&2
echo. 1>&2

call :loadSettings "global"

if %errorlevel% leq 0 (
	set ImageMagickPath=%PROGRAMFILES%\ImageMagick-6.7.1-Q16
	set /a numberOfProcesses=5
	set /a showElapsedTime=0
	set /a useImagePadding=1
)
echo   %numberOfProcesses% worker process(es) will be used 1>&2

set menuTextPad=
if %useImagePadding% equ 1 set menuTextPad=, pad,

set convert="%ImageMagickPath%\convert.exe"
set identify="%ImageMagickPath%\identify.exe"

set mangafoxDir=mangafox.com
set eofMarker=~~~EOF~~~.gif
set eofMarkerOpt=-background white -fill black -pointsize 96 -font Arial -gravity center

set scanFolder="%CD%"
set fileFilter=*.jpg *.jpeg *.png *.gif *.bmp
set dirOptions=/b /s /A-d /o:ng

set batch=
set deleteOriginal=

set actionGroupFiles=
set actionSwapFiles=
set actionPadImage=

set rotate="-90^<"
set crop=
set crop1=
set trim=
set extent=
set fileMul=1
set addMarker=

set extentBackground=-background white

set activeConfig=BW

call :loadSettings "resize"

if %errorlevel% leq 0 (
	set resizeClause=-resize "2000x>"
)

set halfCrop="100%%%%x50%%%%"

:: COWON A3 screen width
set screenWidth=800
:: COWON A3 screen height
set screenHeight=480

call :loadSettings "crop"

if %errorlevel% leq 0 (
	set cropPictureX=203
	set cropPictureY=281
	set cropPictureHeight=1180
)

set cropPictureHeightOrig=%cropPictureHeight%
set cropPictureWidth=%screenWidth%
set cropHeightVal=%screenHeight%

set /a _=cropPictureHeight %% cropHeightVal
if %_% gtr 0 set /a cropPictureHeight=cropHeightVal*((cropPictureHeight/cropHeightVal)+1)

:: Format <width>x<height>!+<x offset>+<y offset>
set cropPicture="%cropPictureWidth%x%cropPictureHeightOrig%!+%cropPictureX%+%cropPictureY%" -extent "%cropPictureWidth%x%cropPictureHeight%"

set cropHeight="x%cropHeightVal%!"

set jpgQuality=-quality 93
set pngQuality=-quality 95
set tempQuality=-quality 01

set groupFilesActivePath=
set skipFolder=

call :loadSettings "group"

if %errorlevel% leq 0 (
	set /a groupFilesCountPerFolder=30
)

set /a groupFilesLastFileIndex=1
set /a groupFilesActiveFolderIndex=1

:LOAD_CONFIG

call :loadSettings "modes\%activeConfig%"

if %errorlevel% leq 0 (
	set imageBorder=-bordercolor "#FFFFFF" -border 4x2
	set trimDistanceBlackValue=45
	set trimDistanceWhiteValue=45
)

set trimDistanceBlack="%trimDistanceBlackValue%%%%%"
set trimDistanceWhite="%trimDistanceWhiteValue%%%%%"
set trimClause=-mattecolor "#000000" -frame 2 -fuzz %trimDistanceBlack% -trim -mattecolor "#FFFFFF" -frame 2 -fuzz %trimDistanceWhite% -trim

set warn=*** WARNING: FILES WILL BE MODIFIED INPLACE ***

:CHOICE

cd %scanFolder% || exit /b 1

echo. 1>&2
echo %warn% 1>&2
echo. 1>&2
echo Folder and subfolders to be processed: %scanFolder% 1>&2
echo. 1>&2
echo %warn% 1>&2
echo. 1>&2
echo 0. Exit. 1>&2
echo. 1>&2
echo *. %activeConfig% mode is active 1>&2
echo. 1>&2
echo A. Rotate, trim white border%menuTextPad% group, add EOF 1>&2
echo B. Yonkoma split, rotate, trim white border%menuTextPad% group, add EOF 1>&2
echo C. 2-pages manga split, rotate, trim white border%menuTextPad% group, add EOF 1>&2
echo D. Adjust page size, split by height=%cropHeightVal%px%menuTextPad% group, add EOF 1>&2
echo. 1>&2
echo 1. Rotate only 1>&2
echo 2. Yonkoma (height ^> width) split and rotate (Right to Left). Original files will be deleted 1>&2
echo 3. 2-pages manga (width ^>= height) split and rotate (Right to Left). Original files will be deleted 1>&2
echo 4. Crop images by width=%cropPictureWidth%px, height=%cropPictureHeight%px, x=%cropPictureX%px, y=%cropPictureY%px 1>&2
echo 5. Crop images by height=%cropHeightVal%px. Original files will be deleted 1>&2
echo 6. Trim image borders using color distances: black=%trimDistanceBlackValue%%%, white=%trimDistanceWhiteValue%%% 1>&2
echo 7. Group files by %groupFilesCountPerFolder% files per folder 1>&2
echo 8. Add EOF image for each folder with images 1>&2
echo 9. Swap split images 1>&2
echo J. Pad images to avoid auto stretching 1>&2

echo. 1>&2

set /p action=Action: 1>&2

call :toLowerCase action 

set action=%action:~0,1%

:: 0. Exit.
if "%action%"=="0" (
	echo. 1>&2
	echo No action selected. 1>&2
	exit /b 1
)
:: *. Change scheme.
if "%action%"=="*" (
	if "%activeConfig%"=="BW" (
		set activeConfig=Color
	) else (
		set activeConfig=BW
	)
	echo. 1>&2
	goto LOAD_CONFIG
)
:: 1. Rotate only
if "%action%"=="1" (
	goto START
)
:: 2. Yonkoma (height ^> width) split and rotate (Right to Left). Original files will be deleted
if "%action%"=="2" (
	set deleteOriginal=1
	set crop=%halfCrop%
	goto START
)
:: 3. 2-pages manga (width ^>= height) split and rotate (Right to Left). Original files will be deleted
if "%action%"=="3" (
	set rotate="-90^>"
	set deleteOriginal=1
	set crop=%halfCrop%
	goto START
)
:: 4. Crop images by width=%cropPictureWidth%px, height=%cropPictureHeight%px, x=%cropPictureX%px, y=%cropPictureY%px
if "%action%"=="4" (
	set rotate=
	set crop=%cropPicture%
	goto START
)
:: 5. Crop images by height=%cropHeightVal%px. Original files will be deleted
if "%action%"=="5" (
	set deleteOriginal=1
	set rotate=
	set extent=-extent "x%cropPictureHeight%" %extentBackground%
	set crop=%cropHeight%
	goto START
)
:: 6. Trim image borders using color distances: black=%trimDistanceBlackValue%%%, white=%trimDistanceWhiteValue%%%
if "%action%"=="6" (
	set rotate=
	set trim=1
	goto START
)
:: 7. Group files by %groupFilesCountPerFolder% files per folder
if "%action%"=="7" (
	set actionGroupFiles=1
	goto START
)
:: 8. Add EOF image for each folder with images
if "%action%"=="8" (
	set addMarker=1
	set /a groupFilesCountPerFolder=10000000
	set actionGroupFiles=1
	goto START
)
:: 9. Swap split images.
if "%action%"=="9" (
	set actionGroupFiles=1
	set actionSwapFiles=1
	goto START
)
:: J. Pad images to avoid auto stretching.
if "%action%"=="j" (
	set /a useImagePadding=1
	set actionPadImage=1
	goto START
)
:: A. Rotate, trim white border, group, add EOF
if "%action%"=="a" (
	set addMarker=1
	set batch=1
	set trim=1
	set actionGroupFiles=1
	goto START
)
:: B. Yonkoma split, rotate, trim white border, group, add EOF
if "%action%"=="b" (
	set addMarker=1
	set fileMul=2
	set batch=1
	set trim=1
	set actionGroupFiles=1
	set deleteOriginal=1
	set crop=%halfCrop%
	goto START
)
:: C. 2-pages manga split, rotate, trim white border, group, add EOF
if "%action%"=="c" (
	set addMarker=1
	set fileMul=2
	set rotate="-90^>"
	set batch=1
	set trim=1
	set actionGroupFiles=1
	set deleteOriginal=1
	set crop=%halfCrop%
	goto START
)
:: D. Adjust page size, split by height=%cropHeightVal%px, group, add EOF
if "%action%"=="d" (
	set addMarker=1
	set fileMul=3
	set rotate=
	set deleteOriginal=1
	set actionGroupFiles=1
	set crop=%cropPicture%
	set crop1=-crop %cropHeight%
	set extent=-extent "x%cropPictureHeight%" %extentBackground%
	goto START
)

echo. 1>&2
echo Invalid choice. Try again. 1>&2
goto CHOICE

:START

set batchMode=

if not "%batch%"=="" set batchMode=1
if not "%crop1%"=="" set batchMode=1

echo. 1>&2

echo @echo off

echo.
echo ::Script params:
echo ::  %%1 - start image index. First image if omitted.
echo ::  %%2 - end image index (inclusive). Last image if omitted.

echo.
echo set /a numberOfProcesses=%numberOfProcesses%
echo set /a showElapsedTime=%showElapsedTime%
echo set /a useImagePadding=%useImagePadding%

echo.
echo echo.

echo.
echo if not exist %convert% (
echo 	echo %convert% is not found. Reasons:
echo 	echo.
echo 	echo 1. ImageMagick path is invalid. Check "a3images.setting\global.bat" and adjust 'ImageMagickPath' variable.
echo 	echo 2. ImageMagick is not installed. Download Windows binaries at http://www.imagemagick.org/script/binary-releases.php#windows
echo 	goto ERROR
echo )

echo.
echo set startTime=%%TIME%%

echo.
echo goto GET_SIZE

echo.
echo :BEGIN

echo.
echo if %%totalFileCount%% leq 0 (
echo 	echo.
echo 	echo No files to process.
echo 	exit /b 1
echo )

echo.
echo if "%%~1"=="" (
echo 	set /a fileIndex=1
echo ) else (
echo 	set /a fileIndex=0+%%~1
echo )

echo.
echo if %%fileIndex%% leq 0 set /a fileIndex=1

set msgErrIndex=ERROR: There is no file with index

echo.
echo if %%fileIndex%% gtr %%totalFileCount%% (
echo 	echo.
echo 	echo %msgErrIndex% %%fileIndex%%
echo 	goto ERROR
echo )

echo.
echo set /a firstFileIndex=%%fileIndex%%

echo.
echo if "%%~2"=="" (
echo 	set /a lastFileIndex=%%totalFileCount%%
echo ) else (
echo 	set /a lastFileIndex=0+%%~2
echo )

echo.
echo if %%lastFileIndex%% leq 0 set /a lastFileIndex=%%totalFileCount%%

echo.
echo if %%lastFileIndex%% gtr %%totalFileCount%% (
echo 	echo.
echo 	echo %msgErrIndex% %%lastFileIndex%%
echo 	goto ERROR
echo )

echo.
echo set /a processedFileCount=%%lastFileIndex%%-%%fileIndex%%+1

echo.
echo if %%processedFileCount%% leq 0 (
echo 	echo.
echo 	echo ERROR: Start image index must be less or equal than end image index.
echo 	goto ERROR
echo )

echo.
echo if not "%%~1"=="" goto FILE_%%fileIndex%%
echo if %%numberOfProcesses%% leq 1 goto FILE_1
echo.
echo set /a filesPerProcess=%%totalFileCount%% / %%numberOfProcesses%%
echo if %%filesPerProcess%% leq 0 set /a filesPerProcess=1
echo.
echo set /a startFrom=0
echo set /a endTo=0
echo.
echo :NEXT_PROCESS
echo.
echo set /a numberOfProcesses=%%numberOfProcesses%%-1
echo.
echo set /a startFrom=%%endTo%%+1
echo set /a endTo=%%endTo%%+%%filesPerProcess%%
echo.
echo if %%endTo%% gtr %%totalFileCount%% set /a endTo=%%totalFileCount%%
echo if %%numberOfProcesses%% leq 0 set /a endTo=%%totalFileCount%%
echo.
echo echo Start image processing from %%startFrom%% to %%endTo%%...
echo start "" /min "%%~0" %%startFrom%% %%endTo%%
echo.
echo if %%errorlevel%% gtr 0 (
echo 	echo.
echo 	echo ERROR: Could not start process.
echo 	goto ERROR
echo )
echo.
echo if %%endTo%% neq %%totalFileCount%% goto NEXT_PROCESS
echo.
echo echo.
echo echo Please wait until all processes are completed.
echo echo.
echo.
echo echo %%totalFileCount%% file(s) will be processed.
echo.
echo exit /b 0

set /a totalFileCount=0

for /f "delims=" %%i in ('dir %fileFilter% %dirOptions%') do (
	set /a totalFileCount+=1
	call :rotateImg "%%i"
	echo.
	echo set /a fileIndex=%%fileIndex%% + 1
)

if %totalFileCount% gtr 0 (
	echo.
	if not "%actionGroupFiles%"=="" call :addEOFMarker
	echo.
	echo :END
	echo.
	echo ::Footer
	echo echo.
	echo echo Processed %%processedFileCount%% file^(s^).
) else (
	echo. 1>&2
)

echo.
echo set exitType=
echo.
echo echo.
echo if %%firstFileIndex%% equ 1 (
echo 	echo Started: %%startTime%%
echo 	set exitType=/b
echo )
echo.
echo if %%lastFileIndex%% equ %%totalFileCount%% (
echo 	echo   Ended: %%TIME%%
echo 	set exitType=/b
echo )
echo.

echo if %%totalFileCount%% equ %%processedFileCount%% set exitType=/b
echo.

echo if %%showElapsedTime%% equ 0 set exitType=
echo.

if not %totalFileCount% gtr 0 echo ::Footer
echo echo.
echo echo All OK.
echo echo.
echo exit %%exitType%% 0
echo echo.
call :renderPadImage

echo.
echo :GET_SIZE
echo set /a totalFileCount=%totalFileCount%
echo goto BEGIN

echo.
echo :ERROR
echo echo.
echo echo ERROR: Could not process file. %outScript% failed.
echo echo.
echo exit /b 1

echo Script %outScript% is generated. 1>&2	

exit /b 0

:rotateImg

echo.
echo :FILE_%totalFileCount%
echo.
echo if %%fileIndex%% gtr %%lastFileIndex%% goto END
echo.

set extOrig=%~x1
set ext="%~x1"

call :toLowerCase ext

set imgFile="%~1"

if not "%batchMode%"=="" goto CONTINUE

if not "%actionGroupFiles%"=="" (
	call :groupFiles %imgFile%
	exit /b
)

:CONTINUE

echo ::File
call :showProgress %imgFile%
	
set quality=
	
if /i %ext%==".jpg"	set quality=%jpgQuality%
if /i %ext%==".jpeg"	set quality=%jpgQuality%
if /i %ext%==".png"	set quality=%pngQuality%

echo attrib -r %imgFile% ^|^| goto ERROR

set rotateClause=
set cropClause=
set fullTrimClause=

set outImgFile=%imgFile%
set origImgFile=%imgFile%

if not "%rotate%"==""	set rotateClause=-rotate %rotate%
if not "%crop%"==""	set cropClause=-crop %crop%
if not "%trim%"==""	set fullTrimClause=-gravity West %trimClause% -gravity North %trimClause% -gravity East %trimClause% -gravity South %trimClause% -gravity NorthWest %imageBorder% %resizeClause%

set "fileNameWOExt=%~dpn1-"
if not "%deleteOriginal%"=="" set outImgFile="%fileNameWOExt%%%%%d%extOrig%"

set intImg1="%fileNameWOExt%0.png"
set intImg2="%fileNameWOExt%1.png"
set outImg1="%fileNameWOExt%0%extOrig%"
set outImg2="%fileNameWOExt%1%extOrig%"
set outImg3="%fileNameWOExt%2%extOrig%"

if not "%crop1%"=="" (
	echo %convert% %cropClause% +repage %imgFile% %tempQuality% png:- ^| %convert% %extent% %crop1% %quality% +repage - %outImgFile% ^|^| goto ERROR
	call :groupFiles %outImg1%
	call :groupFiles %outImg2%
	call :groupFiles %outImg3%
	goto continueRotate
)

set mangaFoxFooterTrim=
echo %imgFile% | find /i "\%mangafoxDir%\" 1>&2 > nul
if %errorlevel% leq 0 set mangaFoxFooterTrim=-gravity south -chop x36
set inImgFile=-
if "%mangaFoxFooterTrim%"=="" (
	set inImgFile=%imgFile%
)

if "%batch%"=="" (
	if not "%actionPadImage%"=="" goto actionPadImage
	:: Other single actions.
	call :renderMangaFoxFooterTrim
	echo %convert% %extent% %rotateClause% %cropClause% %quality% %fullTrimClause% +repage %inImgFile% %outImgFile% ^|^| goto ERROR
	goto continueRotate
	:: Pad image action.
	:actionPadImage
	echo call :padImage %imgFile% "%quality%"
	goto continueRotate
)

:: else not "%batch%"==""

if "%crop%"=="" (
	echo %convert% %mangaFoxFooterTrim% %rotateClause% +repage %imgFile% %tempQuality% png:- ^| %convert% %extent% %quality% %fullTrimClause% +repage - %outImgFile% ^|^| goto ERROR
	echo call :padImage %imgFile% "%quality%"
	call :groupFiles %imgFile%
) else (
	call :renderMangaFoxFooterTrim
	echo %convert% %rotateClause% %cropClause% %tempQuality% +repage %inImgFile% "%fileNameWOExt%%%%%d.png" ^|^| goto ERROR
	echo %convert% %extent% %quality% %fullTrimClause% +repage %intImg1% %outImg1% ^|^| goto ERROR
	echo call :padImage %outImg1% "%quality%"
 	echo %convert% %extent% %quality% %fullTrimClause% +repage %intImg2% %outImg2% ^|^| goto ERROR
	echo call :padImage %outImg2% "%quality%"
 	if /i not %ext%==".png" echo del "%fileNameWOExt%?.png" ^|^| goto ERROR
	call :groupFiles %outImg1%
	call :groupFiles %outImg2%
)

:continueRotate

if not "%deleteOriginal%"=="" echo del %origImgFile% ^|^| goto ERROR

exit /b

:groupFiles
set "imgPath=%~dp1"
set imgFile="%~1"
set "imgFileName=%~nx1"
set leadingZeroes=

:: Swap split files.
if not "%actionSwapFiles%"=="" (
	if "%groupFilesActivePath%"=="%imgPath%" exit /b
	echo ::Move
	call :showProgress "%imgPath%"
	echo if exist "%imgPath%*-0.*"  ren  "%imgPath%*-0.*"  "*-00.*" ^|^| goto ERROR
	echo if exist "%imgPath%*-1.*"  ren  "%imgPath%*-1.*"  "*-0.*"  ^|^| goto ERROR
	echo if exist "%imgPath%*-00.*" ren  "%imgPath%*-00.*" "*-1.*"  ^|^| goto ERROR
	set "groupFilesActivePath=%imgPath%"
	exit /b
)

:: Group files.
if "%groupFilesActivePath%"=="%imgPath%" (
	if not "%skipFolder%"=="" exit /b
	set /a groupFilesLastFileIndex+=1
	goto continueGrouping
)

:: else "%groupFilesActivePath%"!="%imgPath%"

if not "%groupFilesActivePath%"=="" call :addEOFMarker

set "groupFilesActivePath=%imgPath%"
	
for /f "tokens=*" %%i in ('dir /b /A-d "%groupFilesActivePath%" ^| find "" /v /n /c') do ( set /a filesInFolder=%%i )

set /a filesInFolder*=fileMul
	
if %filesInFolder% leq %groupFilesCountPerFolder% (
	set "newFilePath=%imgPath%"
	set skipFolder=1
	exit /b
) else (
	set skipFolder=
)

set /a groupFilesLastFileIndex=1
set /a groupFilesActiveFolderIndex=1

:continueGrouping

if %groupFilesLastFileIndex% gtr %groupFilesCountPerFolder% (
	set /a groupFilesLastFileIndex=1
	set /a groupFilesActiveFolderIndex+=1
	call :addEOFMarker
)

if %groupFilesActiveFolderIndex% lss 10 set leadingZeroes=0

set "newFilePath=%imgPath%%leadingZeroes%%groupFilesActiveFolderIndex%\"

if not "%batchMode%"=="" goto continueMove

echo ::File
call :showProgress %imgFile%

:continueMove

if "%batchMode%"=="" echo attrib -r %imgFile% ^|^| goto ERROR

echo.
echo ::Move
echo if not exist "%newFilePath%" md "%newFilePath%"
echo move %imgFile% "%newFilePath%" ^|^| goto ERROR

exit /b

:addEOFMarker
if "%addMarker%"=="" exit /b
if "%eofMarker%"=="" exit /b
set _="%newFilePath%%eofMarker%"
echo.
echo ::EOF
echo if not exist %_% (
echo 	if not exist "%newFilePath%" md "%newFilePath%"
echo 	echo Creating EOF image at "%newFilePath%"...
echo 	%convert% -size "%screenWidth%x%screenHeight%" %eofMarkerOpt% "label:E\nO\nF" -rotate 90 -annotate 0 "E\n \nF" -rotate -90 %_% ^|^| goto ERROR
echo )
exit /b

:loadSettings
set _="%settingsDir%\%~1.bat"
if exist %_% (
	echo Loading %_%... 1>&2
	call %_%
	exit /b 1
)
exit /b 0

:showProgress
echo.
echo set /a percent=%%fileIndex%% * 100 / %%lastFileIndex%%
echo if %%percent%% lss 10 (
echo 	set "percentPad=  "
echo ) else (
echo 	set "percentPad= "
echo )
echo if %%percent%% equ 100 set "percentPad="
echo title %%percent%%%%%% #%%fileIndex%%/%%lastFileIndex%% %1...
echo echo %%percentPad%%%%percent%%%%%% #%%fileIndex%%/%%lastFileIndex%%	%1...
echo.
exit /b

:toLowerCase
:: http://www.robvanderwoude.com/battech_convertcase.php
:: Subroutine to convert a variable VALUE to all lower case.
:: The argument for this subroutine is the variable NAME.
for %%i in ("A=a" "B=b" "C=c" "D=d" "E=e" "F=f" "G=g" "H=h" "I=i" "J=j" "K=k" "L=l" "M=m" "N=n" "O=o" "P=p" "Q=q" "R=r" "S=s" "T=t" "U=u" "V=v" "W=w" "X=x" "Y=y" "Z=z") do call set "%1=%%%1:%%~i%%"
exit /b

:renderPadImage
echo.
echo :padImage
:: Pads image to fit it in screen to avoid forcible stretching.
:: %1 - file name.
:: %2 - quality.
echo if %%useImagePadding%% equ 0 exit /b
echo.
echo set imgToPad="%%~1"
echo set quality=%%~2
echo.
echo for /F "tokens=1,2 delims=x" %%%%a in ('start "" /b /wait %identify% -format "%%%%wx%%%%h" %%imgToPad%%') do ( 
echo 	set /a w=%%%%a
echo 	set /a h=%%%%b 
echo )
echo.
echo if %%w%% geq %screenHeight% (
echo 	if %%h%% geq %screenHeight% exit /b
echo 	if %%w%% geq %screenWidth% exit /b
echo 	set /a h=%screenHeight%
echo 	goto doPadImage
echo )
echo.
echo if %%h%% lss %screenHeight% (
echo 	set /a w=%screenHeight%
echo 	set /a h=%screenHeight%
echo 	goto doPadImage
echo )
echo.
echo if %%h%% lss %screenWidth% (
echo 	set /a w=%screenHeight%
echo 	goto doPadImage
echo )
echo.
echo exit /b
echo.
echo :doPadImage
echo echo Padding %%imgToPad%%...
echo %convert% -gravity center -extent %%w%%x%%h%% xc:white +repage %%imgToPad%% %%quality%% -gravity center -composite %%imgToPad%% ^|^| goto ERROR
echo.
echo exit /b

:renderMangaFoxFooterTrim
if not "%mangaFoxFooterTrim%"=="" echo.|set /p _="%convert% %mangaFoxFooterTrim% %imgFile% %tempQuality% png:- | "
exit /b
